/* *************************************************************************
 * Copyright (C) 2017 - Trelleborg Marine Systems
 * Author		:	Vincent Vuarnoz
 * Date			:	13 Sep 2017
 * Description	:	See header file
 * *************************************************************************
 */

#include "clock.h"
#include "timer.h"

/* Functions Definitions */
uint32_t clock_get_current_time(void) {
	return timer_get_count_ms();
}

uint32_t clock_diff_to_now(uint32_t old) {

	uint32_t now = timer_get_count_ms();
	if(now < old) {
		// Counter wrapped around
		uint32_t res;
		res = UINT32_MAX - old;
		res += now;
		return res;
	}
	else {
		return (now - old);
	}
}

void clock_delay_ms(uint32_t delay) {
	uint32_t now = clock_get_current_time();
	while(clock_diff_to_now(now) < delay);
}

void clock_delay_10us(uint32_t delay_us) {
	uint32_t now = timer_get_count_10us();
	while(timer_get_count_10us()-now < delay_us);
}
