/* *************************************************************************
 * Copyright (C) 2017 - Trelleborg Marine Systems
 * Author		:	Vincent Vuarnoz
 * Date			:	04 Sep 2017
 * Description	:	Provides debug functionalities.
 * ************************************************************************/
#ifndef _DEBUG_H_
#define _DEBUG_H_

/* TI-Driver includes */
#include <ti/drivers/UART.h>
#include "Board.h"

// Enable the different levels of debug outputs
#define DEBUG_INFO_ENABLE 1
#define DEBUG_WARNING_ENABLE 1
#define DEBUG_ERROR_ENABLE 1

/* Defines */
#if DEBUG_INFO_ENABLE == 1
	#define DEBUG_INFO(x, ...) Report(x, ##__VA_ARGS__)
#else
	#define DEBUG_INFO(x, ...)
#endif

#if DEBUG_WARNING_ENABLE == 1
	#define DEBUG_WARNING(x, ...) Report(x, ##__VA_ARGS__)
#else
	#define DEBUG_WARNING(x, ...)
#endif

#if DEBUG_ERROR_ENABLE == 1
	#define DEBUG_ERROR(x, ...) Report(x, ##__VA_ARGS__)
#else
	#define DEBUG_ERROR(x, ...)
#endif

#define ERR_PRINT(x) Report("Error [%d] at line [%d] in function [%s]  \n\r",x,__LINE__,__FUNCTION__)
#define UART_INFO(x, ...)

/* Public methods declarations */
void debug_init(void);

int Report(const uint8_t *pcFormat, ...);

void Message(const uint8_t *str);

#endif // _DEBUG_H_
