/* *************************************************************************
 * Copyright (C) 2017 - Trelleborg Marine Systems
 * Author		:	Vincent Vuarnoz
 * Date			:	23 Jan 2018
 * Description	:	See header file
 * *************************************************************************
 */

#include "watchdog.h"
#include <ti/drivers/Watchdog.h>
#include "Board.h"

#include <stddef.h>

/* Private Variables */

/* Callback */
void callbackFxn(uintptr_t handle);

/* Functions Definitions */

void watchdog_init(void) {
	Watchdog_Params params;
	Watchdog_Handle handle;

	Watchdog_init();

	Watchdog_Params_init(&params);
	params.resetMode = Watchdog_RESET_ON;
	params.callbackFxn = callbackFxn;
	params.debugStallMode = Watchdog_DEBUG_STALL_ON;
	handle = Watchdog_open(Board_WATCHDOG0, &params);
	if (handle == NULL) {
#ifdef _DEBUG_
	    while(1);
#endif
	}
}


// Note: if the application is in a while(1); expression this callback will still be called
void callbackFxn(uintptr_t handle_) {
	Watchdog_clear((Watchdog_Handle)handle_);
}

